#include "include\classes.h"

extern "C" void ListAlloc(int Start = 1);
extern "C" int MaxAlloc;

extern "C" char tempstring[SmallBufferLen];
extern "C" char tempout[BufferLen];
extern "C" char tempout2[BufferLen];
extern "C" char tempout3[BufferLen];
extern "C" char tempout4[BufferLen];

extern "C" LARGE_INTEGER qwFreq;

CharTemplate CTtmp;

clsChar cDumpChar;
clsEquip eDumpEquip;

unsigned char Colour[125];

void AddFeat(clsChar* TargetStruct, char* FeatName, int* featsyet = NULL, int Dep = -2);
void AddFeat(clsChar* TargetStruct, int FeatNumber, int* featsyet = NULL, int Dep = -2);
extern int AdvancedRand(int number, const int* firstval, int jump, const char* Text, int TextJump, char* Text2, int OverrideManual = 0, int TextPointer = 0);
int asc(char* chr);
void CalcMods(clsChar* TargetStruct);
void ChangeChar(clsChar* TargetStruct, int i);
void CharSourceExit();
int CharSourceInit();
bool CheckReq(clsChar* TargetStruct, int FeatNumber, int featsyet, char* ReqStr, int curlevel = 0, int* AgainProb = 0);
void ClearChar(clsChar* TargetStruct);
int CountSetLines(FILE* fFile);
void DoMonsterDesc(clsChar* TargetStruct, char* FileName);
bool FeatPresent(clsChar* TargetStruct, int FeatNumber, int featsyet, int FeatDep = -2);
char* GetAttributeName(int Number);
char* GetElement(int Num = -1, int inBrackets = 0);
int GetMonsterTypeNumber(char* MonsterType);
int GetSizeNumber(char* Size);
int HighestVal(int* Array, int Number);
unsigned int hoch(unsigned int base, unsigned int exp);
unsigned int intpart(unsigned int val, unsigned int part);
void isaacinitrand(unsigned long* seed, bool randomdoseed = true);
extern unsigned int isaacrand(unsigned int Min, unsigned int Max, bool Init = false, unsigned long int* seed = NULL);
void MixChar(clsChar* TargetStruct);
void ProcessLine(FILE *fFile, void (*ProcessFunction)(char* Vals[32], void* TargetStruct, int Number, bool header), void* TargetStruct, bool header);
extern unsigned int random(int min, int max, char* Text, int OverrideManual = 0);
void RandAttributes(clsChar* TargetStruct, int type);
void RandClass(clsChar* TargetStruct, int type, int multiclass, int* finished);
int run();
void SetConsole(int Num, int Set = 1);
void SetCharSource(char** Vals, void* TargetStruct);
void SetFeatSkills(clsChar* TargetStruct);
void SourceExit();
int SourceInit();
int SummarizeArray(int* Array, int Number);

int manual = 0;
int manual2;
extern "C" int DebugOutput;
int RuntimeOutput = 0;

int worktype;
bool UseIsaac = false;
bool IsaacInitDone;

CharTemplate reheader;
int reproduce = 1, reproduceisaac = 0;
int readreproduce = 0, readreproducea = 0;

int InitPassed = 0;

unsigned int* retemp;
unsigned int* prepos;

FILE* reRead;

int loop = 0;
int loopdisplay = CONF_DisplayLoop;
int adverror = 1;
int DummyChar = 0;
clsChar* dummySource;

int randstackinit = 0;
int randstacktmp;
int randstack;
int arandstack;

int calctype;
int TestScript = 0;

unsigned int* AgainDep;

unsigned long seed[256];

const int FixedProb = 1;

void str_replace(char val1, char val2, char* val, int len = 0)
{
	int i;

	if (len == 0)
	{
		len = strlen(val);
	}

	for (i = 0;i < len;i++)
	{
		if (val[i] == val1)
		{
			val[i] = val2;
		}
	}
}

void saverep(char* repfile, bool force = false)
{
	FILE* fRe;
	int i;
	char fullrepfile[SmallBufferLen] = "Save\\";

	if (reproduce == 1 || reproduceisaac || force)
	{
		strcat(fullrepfile, repfile);
		str_replace(asc("\\"), asc("-"), fullrepfile + 5);

		fRe = fopen(fullrepfile, "wb");
		if (fRe == 0)
		{
			printf("Fatal Error\nCould not Open Output File\n");
			getchar();
			return;
		}

		CopyMemory(&reheader, "DNDV", 4);

		fwrite(&reheader, sizeof(CharTemplate) - sizeof(CharTemplate::restru) - sizeof(CharTemplate::seedstru), 1, fRe);

		if (reheader.TemplateType == 49)
		{
			fwrite(&reheader.seed.seed[0], sizeof(CharTemplate::seedstru), 1, fRe);
		}
		else
		{
			for (i = 0;i < (signed) *prepos;i++)
			{
				fprintf(fRe, "%d\n", retemp[i]);
			}
		}

		fclose(fRe);
		if (loop == 0)
		{
			printf("Reproduction file has been saved as %s\n", repfile);
		}
	}
}

void quitprog(bool save = true)
{
	loop = 0;
	if (InitPassed && save)
	{
		saverep("error.rep");
	}
	printf("Quitting due to error\n");
	getchar();
	getchar();

	#ifndef debugruntime
		exit(1);
	#else
		throw("quitprog");
	#endif

	return;
}

int TwoCharToInt(char* val, bool varsize = false)
{
	if (varsize == false || strlen(val) != 1)
	{
		return((int) (*((unsigned short*) val)));
	}
	else
	{
		return((int) val[0]);
	}
}

int substr_count(char val1, char* val, int len = 0)
{
	int i, num = 0;

	if (len == 0)
	{
		len = strlen(val);
	}

	for (i = 0;i < len;i++)
	{
		if (val[i] == val1)
		{
			num++;
		}
	}
	return(num);
}

unsigned int hoch(unsigned int base, unsigned int exp)
{
	unsigned int i;
	unsigned int temp = 1;
	for (i = 0;i < exp;i++)
	{
		temp *= base;
	}
	return(temp);
}

unsigned int intpart(unsigned int val, unsigned int part)
{
	val = val % (hoch(16, part));
	val = val / (hoch(16, part - 1));
	return(val);
}

int SummarizeArray(int* Array, int Number)
{
	int temp = 0, i;
	for (i = 0;i < Number;i++)
	{
		temp += Array[i];
	}
	return(temp);
}

int GreaterZero(int val)
{
	if (val > 1)
	{
		return(val);
	}
	else
	{
		return(1);
	}
}

int HighestVal(int* Array, int Number)
{
	int temp = 0, tempnum = 0, i;
	for (i = 0;i < Number;i++)
	{
		if (Array[i] > temp)
		{
			temp = Array[i];
			tempnum = i;
		}
	}
	return(tempnum);
}

double absd(double val)
{
	return((val < 0 ? - val : val));
}

int Enhence(int Level)
{
	int i;
	int probs[7];

	if (Level > 20)
	{
		return(((signed) random(20, 55, "Artifakt = 0") < Level ? 6 : 5));
	}

	for (i = 0;i < 7;i++)
	{
		probs[i] = (int) ((double) 50000 / (((double) Level / 4 - i) * ((double) Level / 4 - i) * absd((double) Level / 4 - i) * 4 + 1));
	}

	probs[6] /= 1000;

	i = AdvancedRand(7, probs, sizeof(int), "", 0, "Verbesserung Auswhlen!");
	return(i);
}

void SecureMultiply(int* Value, int Factor)
{
	if (*Value > 500000000 / Factor)
	{
		*Value = 500000000;
	}
	else
	{
		*Value *= Factor;
	}
}

void InsertEquip(clsChar* TargetStruct, int SourceID, int DestID)
{
	ZeroMemory(&TargetStruct->Equipment[DestID], sizeof(clsEquip));

	TargetStruct->Equipment[DestID].ID = SourceID;
	TargetStruct->Equipment[DestID].Armor = Source.EquipSource[SourceID].Armor;
	TargetStruct->Equipment[DestID].AttackType = Source.EquipSource[SourceID].AttackType;
	TargetStruct->Equipment[DestID].Critical = Source.EquipSource[SourceID].Critical;
	TargetStruct->Equipment[DestID].CriticalMultiplier = Source.EquipSource[SourceID].CriticalMultiplier;
	TargetStruct->Equipment[DestID].CriticalMultiplier2 = Source.EquipSource[SourceID].CriticalMultiplier2;
	TargetStruct->Equipment[DestID].Damage1 = Source.EquipSource[SourceID].Damage1;
	TargetStruct->Equipment[DestID].Damage2 = Source.EquipSource[SourceID].Damage2;
	TargetStruct->Equipment[DestID].Damage3 = Source.EquipSource[SourceID].Damage3;
	TargetStruct->Equipment[DestID].EquipType = Source.EquipSource[SourceID].EquipType;
	TargetStruct->Equipment[DestID].Malus = Source.EquipSource[SourceID].Malus;
	TargetStruct->Equipment[DestID].MaxDex = Source.EquipSource[SourceID].MaxDex;
	TargetStruct->Equipment[DestID].Metallic = Source.EquipSource[SourceID].Metallic;
	TargetStruct->Equipment[DestID].Size = Source.EquipSource[SourceID].Size;
	TargetStruct->Equipment[DestID].SpellFailure = Source.EquipSource[SourceID].SpellFailure;
	TargetStruct->Equipment[DestID].Type = Source.EquipSource[SourceID].Type;
}

int mCheckCharsI, mCheckCharsResult;
#define mCheckChars(Value) \
{ \
	mCheckCharsResult = 0; \
	for(mCheckCharsI = 0;mCheckCharsI < TargetStruct->ClassCount;mCheckCharsI++) \
	{ \
		if (Source.CharSource[TargetStruct->Classes[mCheckCharsI]].Value) \
		{ \
			mCheckCharsResult = 1; \
			break; \
		} \
	} \
}

#include "include\clsRead.h"

#include "include\clsDomainSource.h"
#include "include\clsRegionSource.h"
#include "include\clsSizeSource.h"
#include "include\clsSchoolSource.h"
#include "include\clsTemplateSource.h"
#include "include\clsMonsterTypeSource.h"

#include "include\clsCharSource.h"
#include "include\clsFeatSource.h"
#include "include\clsEquipSource.h"
#include "include\clsSkillSource.h"
#include "include\clsRaceSource.h"
#include "include\clsSpellSource.h"
#include "include\clsPowerSource.h"
#include "include\clsEffectSource.h"
#include "include\clsMonsterSource.h"
#include "include\clsProfileSource.h"

#include "include\clsSource.h"

#include "include\script.h"

#include "include\CharMain.h"
#include "include\Equipment.h"
#include "include\Feats.h"
#include "include\Skills.h"
#include "include\Spells.h"
#include "include\Powers.h"
#include "include\Monster.h"
#include "include\CharType.h"
#include "include\clsChar.h"
#include "include\mixed.h"

#include "include\ListData.h"
