void SetRaceSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, prob, size, attack, scriptpos, modpos, valcount, rangepos;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		size = GetValNumber(Vals, "Size", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		modpos = GetValNumber(Vals, "RaceMod", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		rangepos = GetValNumber(Vals, "Range", Number);
		valcount = Number;
		return;
	}
		
	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Race Source Database\n");
		quitprog();
	}

	((clsRace*) TargetStruct)->Name = Vals[name];
	((clsRace*) TargetStruct)->Probability = atoi(Vals[prob]);
	((clsRace*) TargetStruct)->Size = atoi(Vals[size]);
	((clsRace*) TargetStruct)->PreferedAttackType = atoi(Vals[attack]);
	((clsRace*) TargetStruct)->Range = atoi(Vals[rangepos]);

	((clsRace*) TargetStruct)->RaceMod =  Vals[modpos];
	str_replace(asc(";"), 0, ((clsRace*) TargetStruct)->RaceMod.buffer);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsRace*) TargetStruct)->Script)))
	{
		printf("Error in Race Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetRaceNumber(char* RaceName)
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		if (Source.RaceSource[i].Name == RaceName)
		{
			return(i);
		}
	}
	printf("Race not found(%s)\n", RaceName);
	quitprog();
	return(0);
}

void RaceSourceExit()
{
	int i;
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		freel(Source.RaceSource[i].Script);
	}
	delete[] Source.RaceSource;
}
