#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <winbase.h>

#include "include/realloc.h"
extern "C" int MustRebuild;
int MustRebuild;
extern "C" int vAllocOK;
int vAllocOK;
extern "C" int ReserveHigh;
int ReserveHigh = 0;
extern "C" int dwPageSize;
int dwPageSize;

extern unsigned int vAllocList[512 * 1024 / 4 / 9];

#include "defines.h"

#include "include/cpuid.h"

#include "malloclog.h"
#include "include/string.h"
#include "include/classes.h"
extern "C" clsSource Source;
clsSource Source;

extern "C" char tempstring[SmallBufferLen];
extern "C" char tempout[BufferLen];
extern "C" char tempout2[BufferLen];
extern "C" char tempout3[BufferLen];
extern "C" char tempout4[BufferLen];

char tempstring[SmallBufferLen];
char tempout[BufferLen];
char tempout2[BufferLen];
char tempout3[BufferLen];
char tempout4[BufferLen];

extern "C" LARGE_INTEGER qwFreq;
LARGE_INTEGER qwFreq;

extern "C" int DebugOutput;

extern "C" void __cdecl ListAlloc(int Start = 1);

int DebugOutput;

#ifdef buildvsnet
namespace vcnetspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef builddebug
namespace debugspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef buildintel
namespace intelspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef buildvectorc
namespace vectorcspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef buildgcc
	extern "C" void __stdcall _Z14if_gcc_dndmaini(int dump);
#endif

extern "C" int Runtime(int Num, int argc, char** argv);
int Runtime(int Num, int argc, char** argv)
{
	int Start = Num;
	int restarted = 0;

	goto skiprestart;

restart:
	restarted = 1;
	Num++;
	Num %= 6;

	if (Num == Start)
	{
		printf("No suitable Runtime found\n");
		getchar();
		return(1);
	}

skiprestart:

	if (Num == 0)
	{
#ifdef builddebug
		printf("Running Debug Code\n");
		return(debugspace::dndmain(argc, argv));
#else
		printf("Debug Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 1)
	{
#ifdef buildintel
		printf("Running Intel Compiler Northwood Optimized Code\n");
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(intelspace::dndmain(argc, argv));
#else
		printf("Intel Compiler Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 2)
	{
#ifdef buildvectorc
		printf("Running VectorC Compiler Optimized Code\n");
		if (isAthlon() == FALSE)
		{
			printf("WARNING, NO AMD CPU FOUND\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(vectorcspace::dndmain(argc, argv));
#else
		printf("VectorC Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 3)
	{
#ifdef buildgcc
		printf("Running GCC Compiler SSE2 Optimized Code\n");
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		_Z14if_gcc_dndmaini(0);
		return(0);
#else
		printf("GCC Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 4)
	{
#ifdef buildvsnet
		printf("Running Visual C++ .NET Compiler Optimized Code\n");
		return(vcnetspace::dndmain(argc, argv));
#else
		printf("Visual C++ .NET Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 5)
	{
#ifdef buildbcc
		printf("Running Borland C++ Runtime\n");
		return(bccspace::dndmain(argc, argv));
#else
		printf("Borland C++ Runtime not include, Trying another\n");
		goto restart;
#endif
	}

	printf("Unknown Runtime\nExiting...\n");
	getchar();
	return(1);
}

int main(int argc, char** argv)
{
	int StdRun;
	int RetVal;

	printf("DND Chargen V. 0.9 Coded by qon in 2k4\n\n");
	QueryPerformanceFrequency(&qwFreq);

#ifdef DumpSource
	SYSTEM_INFO sSysInfo;
	GetSystemInfo(&sSysInfo);
	dwPageSize = sSysInfo.dwPageSize;

	LPVOID vAlloc;
	vAlloc = VirtualAlloc((void*) (1024 * 1024 * 1024), 512 * 1024 * 1024, MEM_RESERVE, PAGE_READWRITE);
	vAllocOK = (vAlloc != NULL);

	ZeroMemory(vAllocList, 512 * 1024 / 4 / 9);

	if (vAllocOK)
	{
		MustRebuild = ReAlloc("source.dnd", &Source, sizeof(clsSource));
	}
#else
	MustRebuild = 1;
	vAllocOK = 0;
#endif


	if (argc == 2)
	{
		StdRun = atoi(argv[1]);
		printf("Runtime choosen by Argument\n");
	}
	else if (HasSSE2())
	{
		printf("SSE2 capable CPU found, using Intel Compiler Runtime\n");
		StdRun = 1;
	}
	else
	{
		printf("No SSE2 capable CPU found, using Microsoft Compiler Generic Runtime\n");
		StdRun = 4;
	}

	RetVal = Runtime(StdRun, argc, argv);

	if ((!VirtualFree((void*) (1024 * 1024 * 1024), 0, MEM_RELEASE)))
	{
		printf("Failed freeing Memory for some reason, Should make a difference yet though :|\n\n");
		RetVal = 1;
	}

#ifdef malloclog
	ListAlloc();
#endif

	while (kbhit()) {getch();}
	if (RetVal == 1)
	{
		printf("Aborting...\n");
		getchar();
	}
	else
	{
		printf("\nExiting...\n");
	}
	return(RetVal);
}
